@echo off
set files=*.png;*.pcx;*.gif;*.bmp
set exts=bin pscompr psgcompr stcompr
set parts=tiles tilemap

setlocal enabledelayedexpansion
set header=Type
for %%p in (%parts%) do (
  set header=!header! %%p
)
echo %header%
for %%e in (%exts%) do call :testext %%e
pause
goto :eof

:testext
for %%p in (%parts%) do call :testextpart %1 %%p
call :analyse %1
goto :eof

:testextpart
del *-%1.%2 2>nul
for %%f in (%files%) do call :testfile %%f %1 %2
goto :eof

:testfile
..\bmp2tile.exe %1 -removedupes -mirror -save%3 %1-%3.%2 -exit
goto :eof

:analyse
if %1==bin goto :eof
set line=%1
for %%p in (%parts%) do call :analysetype %%p %1
echo %line%
goto :eof

:analysetype
set /a sum=0
set /a base=0
for %%f in (*-%1.%2) do (
  set /a sum=!sum!+%%~zf
)
set /a base=0
for %%f in (*-%1.bin) do (
  set /a base=!base!+%%~zf
)
if %sum%==0 (
  set line=%line% n/a
) else (
  set /a compression=100 - %sum%*100/%base%
  set line=%line% !compression!%%
)
goto :eof